package model;

import static java.lang.Math.abs;
import static model.Ocean.COKE_CAN;
import static model.Ocean.FISH;
import static model.Ocean.SHARK;
import static model.Ocean.STONE;

/**
 * The Class Stone.
 */
public class Stone extends OceanObject {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1702768818822744586L;

	/**
	 * Instantiates a new stone.
	 *
	 * @param ID the id
	 * @param name the name
	 * @param position the position
	 * @param ocean the ocean
	 * @param maximumAge the maximum age
	 * @throws Exception the exception
	 */
	public Stone(int ID, String name, int[] position, OceanInterface ocean,
			int maximumAge) throws Exception {

		super(ID, name, position, ocean, maximumAge);

		setType(STONE);
		setxDirConst(0);
		setyDirConst(9);
		setxDirVar(1);
		setyDirVar(2);
		setHunger(0);
	}

	// ____________________________________________________________

	/**
	 * This method describes the way an object reacts after a collision.
	 * 
	 * @param obj2 the second one of the collision
	 */
	@Override
	public synchronized void reaktion(OceanObject obj2) {

		switch (obj2.getType()) {

		case STONE:

			crushLowerObject(obj2);
			break;

		case FISH:

			youBounce(obj2);

			break;

		case COKE_CAN:

			crushLowerObject(obj2);

			break;

		case SHARK:

			youBounce(obj2);

			break;

		default:
			break;
		}
	}

	/**
	 * Describes the way an objects reacts with the oceans bounds.
	 * 
	 * @param collisionDetected is a collision detected
	 * 
	 */
	@Override
	protected void updateDirectionWhenCollidingWithOceanBounds(
			int collisionDetected) {

		switch (collisionDetected) {

		case KOLLISION_RECHTS:
			setxDirConst(-abs(getxDirConst()));
			setxDirVar(-getxDirVar());

			setDirectionX(-getDirectionX());
			setDirectionY(-getDirectionY());

			break;

		case KOLLISION_OBEN:
			setDirection(new int[] { getDirectionX(), -getDirectionY() });
			setyDirConst(-getyDirConst());
			setyDirVar(-getyDirVar());
			break;

		case KOLLISION_UNTEN:
			setDirection(new int[] { 0, 0 });
			setxDirConst(0);
			setyDirConst(0);
			setxDirVar(0);
			setyDirVar(0);
			break;

		case KOLLISION_LINKS:
			setxDirConst(-getxDirConst());
			setxDirVar(-getxDirVar());

			setDirectionX(-getDirectionX());
			setDirectionY(-getDirectionY());
			break;

		case KEINE_KOLLISION:
			break;

		default:
			break;
		}
	}
}