package view;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

/**
 * The Class AboutFrame.
 */
public class AboutFrame extends JFrame {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The general label. */
	private JLabel allgemein = new JLabel();

	/** The east panel. */
	private JPanel eastPanel = new JPanel();

	/** The fish curve label. */
	private JLabel fishCurveLabel = new JLabel();

	/** The funny code fragments area. */
	private JTextArea funnyCFArea = new JTextArea();

	/** The funny code fragments. */
	private JLabel funnyCodeFragments = new JLabel("funny code\n fragments");

	/** The names. */
	private JLabel names = new JLabel("by tdu, ajs");

	/** The quotes. */
	private JLabel quotes = new JLabel("quote");

	/** The quotes area. */
	private JTextArea quotesArea = new JTextArea();

	/** The scroll fish tab. */
	private JScrollPane scrollFishTab = new JScrollPane(getFishCurveLabel(),
			JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
			JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

	/** The thanks label. */
	private JLabel thanks = new JLabel();

	/** The tp. */
	private JTabbedPane tp = new JTabbedPane(JTabbedPane.TOP,
			JTabbedPane.SCROLL_TAB_LAYOUT);

	// __________________________________________________________________________
	/**
	 * Instantiates a new about frame.
	 */
	public AboutFrame() {

		setTitle("about");
		setVisible(false);
		setResizable(false);

		addLayoutAndLabels();
		formaterAndAddQuotes();
		formaterAndAddFunny();

		putThingsOnThanks();
		putThingsOnGeneral();
		putThingsOnFishCurveLabel();

		setSize(1100, 700);
		setVisible(true);
	}
	// __________________________________________________________________________

	/**
	 * Sets the general label.
	 *
	 * @param allgemein            the allgemein to set
	 */
	public void setAllgemein(JLabel allgemein) {
		this.allgemein = allgemein;
	}

	/**
	 * Sets the east panel.
	 *
	 * @param eastPanel            the eastPanel to set
	 */
	public void setEastPanel(JPanel eastPanel) {
		this.eastPanel = eastPanel;
	}

	/**
	 * Sets the fish curve label.
	 *
	 * @param fishCurveLabel            the fishCurveLabel to set
	 */
	public void setFishCurveLabel(JLabel fishCurveLabel) {
		this.fishCurveLabel = fishCurveLabel;
	}

	/**
	 * Sets the funny cf area.
	 *
	 * @param funnyCFArea            the funnyCFArea to set
	 */
	public void setFunnyCFArea(JTextArea funnyCFArea) {
		this.funnyCFArea = funnyCFArea;
	}

	/**
	 * Sets the funny code fragments.
	 *
	 * @param funnyCodeFragments            the funnyCodeFragments to set
	 */
	public void setFunnyCodeFragments(JLabel funnyCodeFragments) {
		this.funnyCodeFragments = funnyCodeFragments;
	}

	/**
	 * Sets the names.
	 *
	 * @param names            the names to set
	 */
	public void setNames(JLabel names) {
		this.names = names;
	}

	/**
	 * Sets the quotes.
	 *
	 * @param quotes            the quotes to set
	 */
	public void setQuotes(JLabel quotes) {
		this.quotes = quotes;
	}

	/**
	 * Sets the quotes area.
	 *
	 * @param quotesArea            the quotesArea to set
	 */
	public void setQuotesArea(JTextArea quotesArea) {
		this.quotesArea = quotesArea;
	}

	/**
	 * Sets the scroll fish tab.
	 *
	 * @param scrollFishTab the scrallFishTab to set
	 */
	public void setScrollFishTab(JScrollPane scrollFishTab) {
		this.scrollFishTab = scrollFishTab;
	}

	/**
	 * Sets the thanks.
	 *
	 * @param thanks the tanks to set
	 */
	public void setThanks(JLabel thanks) {
		this.thanks = thanks;
	}

	/**
	 * Sets the tp.
	 *
	 * @param tp the tp to set
	 */
	public void setTp(JTabbedPane tp) {
		this.tp = tp;
	}

	/**
	 * Gets the general.
	 *
	 * @return the allgemein
	 */
	public JLabel getAllgemein() {
		return allgemein;
	}

	/**
	 * Gets the east panel.
	 *
	 * @return the eastPanel
	 */
	public JPanel getEastPanel() {
		return eastPanel;
	}

	/**
	 * Gets the fish curve label.
	 *
	 * @return the fishCurveLabel
	 */
	public JLabel getFishCurveLabel() {
		return fishCurveLabel;
	}

	/**
	 * Gets the funny cf area.
	 *
	 * @return the funnyCFArea
	 */
	public JTextArea getFunnyCFArea() {
		return funnyCFArea;
	}

	/**
	 * Gets the funny code fragments.
	 *
	 * @return the funnyCodeFragments
	 */
	public JLabel getFunnyCodeFragments() {
		return funnyCodeFragments;
	}

	/**
	 * Gets the names.
	 *
	 * @return the names
	 */
	public JLabel getNames() {
		return names;
	}

	/**
	 * Gets the quotes.
	 *
	 * @return the quotes
	 */
	public JLabel getQuotes() {
		return quotes;
	}

	/**
	 * Gets the quotes area.
	 *
	 * @return the quotesArea
	 */
	public JTextArea getQuotesArea() {
		return quotesArea;
	}

	/**
	 * Gets the scroll fish tab.
	 *
	 * @return the scrallFishTab
	 */
	public JScrollPane getScrollFishTab() {
		return scrollFishTab;
	}

	/**
	 * Gets the thanks.
	 *
	 * @return the danksagung
	 */
	public JLabel getThanks() {
		return thanks;
	}

	/**
	 * Gets the tp.
	 *
	 * @return the tp
	 */
	public JTabbedPane getTp() {
		return tp;
	}

	/**
	 * Adds the f code to area.
	 */
	public void addFCodeToArea() {

		String code1 = "switch(fall) {\n case KEINE_KOLLISION:\n" +
				"return KEINE_KOLLISION\nbreak;\n case Kollision_OBEN:\n" +
				"return KOLLOSION_OBEN\nbreak;\n}";

		getFunnyCFArea().setRows(6);
		getFunnyCFArea().setColumns(30);
		getFunnyCFArea().setLineWrap(true);
		getFunnyCFArea().setWrapStyleWord(true);

		getFunnyCFArea().setText(code1);
	}

	/**
	 * Adds the layout and labels.
	 */
	public void addLayoutAndLabels() {

		setLayout(new BorderLayout(0, 3));
		add(getTp(), BorderLayout.CENTER);
		getTp().addTab("Allgemeines", null, getAllgemein(), null);
		getTp().addTab("Fish curve", null, getScrollFishTab(), null);
		getTp().addTab("Danksagung", null, getThanks(), null);
		getTp().setVisible(true);
		add(getEastPanel(), BorderLayout.EAST);
		getEastPanel().setLayout(new GridLayout(4, 1));
		getFishCurveLabel().setVisible(true);

		getTp().setSelectedIndex(1);
		add(getNames(), BorderLayout.SOUTH);
	}

	/**
	 * Adds the to quote area.
	 */
	public void addToQuoteArea() {

		String funny1 = "Funny\n";
		String space = "\n......\n";
		String funny2 = "Soll ich dir mal was sagen?\n  Das sieht scheiße aus.";
		String funny3 = "Fishy Fishy Fishy, komm raus wo immer du bist.";
		String funny4 = "Wir machen einfach ein neues Attribut,\ndann läuft das!";
		String funny5 = "Ich habe einen Ordner erlegt... äh... angelegt...";
		getQuotesArea().setText(
				funny1 + space + funny2 + space + funny3 + space + funny4
				+ space + funny5);
	}

	/**
	 * Formatter and add funny.
	 */
	public void formaterAndAddFunny() {

		getEastPanel().add(getFunnyCodeFragments());
		addFCodeToArea();

		JScrollPane scrollFunny = new JScrollPane(getFunnyCFArea(),
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		getEastPanel().add(scrollFunny);
		getFunnyCFArea().setEditable(false);
	}

	/**
	 * Formatter and add quotes.
	 */
	public void formaterAndAddQuotes() {

		getEastPanel().add(getQuotes());
		addToQuoteArea();

		JScrollPane scrollQuotes = new JScrollPane(getQuotesArea(),
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		getEastPanel().add(scrollQuotes);
		getFunnyCFArea().setEditable(false);
	}



	/**
	 * Put things on fish curve label.
	 */
	private void putThingsOnFishCurveLabel() {

		JLabel fl = getFishCurveLabel();

		fl.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 20));

		JLabel uppertext = new JLabel();
		uppertext.setText("Den nach links schauenden Fisch erhält man mit "
				+ "folgender Parametrisierung:\n\n");

		fl.add(uppertext);
		fl.setVisible(true);
		JLabel formulaLabel = new JLabel();
		String filename = null;
		ImageIcon newIcon = null;
		try {
			filename = "images/fishformula.png";

			newIcon = new ImageIcon(getClass().getResource(filename));

			newIcon.setImage(newIcon.getImage().getScaledInstance(504, 136, 0));
		} catch (Exception e) {
			System.err.println("Couldn't load image " + filename);
		}

		formulaLabel.setIcon(newIcon);
		fl.add(formulaLabel);
		JLabel fishImageLabel = new JLabel();

		try {
			filename = "images/gridfish.png";
			newIcon = new ImageIcon(getClass().getResource(filename));
			newIcon.setImage(newIcon.getImage().getScaledInstance(480, 360, 0));
		} catch (Exception e) {
			System.err.println("Couldn't load image " + filename);
		}

		fishImageLabel.setIcon(newIcon);
		fl.add(fishImageLabel);

		JLabel lowertext = new JLabel();
		String toolTipText = "<html>Nach http://en.wikipedia.org/w/index.php?"
				+ "title=Fish_curve&oldid=607527500<br><br>";

		toolTipText += "Die Skalierung in x- und in y-Richtung ist in dem "
				+ "Wikipedia-Artikel gleich;<br> wir haben aus Gründen der "
				+ "Ästhetik mit unterschiedlichen Werten experimentiert.";

		fishImageLabel.setToolTipText(toolTipText);

		fl.add(lowertext);
	}

	/**
	 * Put things on general.
	 */
	private void putThingsOnGeneral() {

		JLabel gl = getAllgemein();

		gl.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 20));

		JTextArea uppertext = new JTextArea();
		uppertext.setRows(6);
		uppertext.setColumns(50);
		uppertext.setLineWrap(true);
		uppertext.setWrapStyleWord(true);
		String uppertextText = "Bei der Erstellung dieser Software "
				+ "sind keine Tiere zu Schaden gekommen. Jedoch könnte der "
				+ "zeitweise erheblich gestiegene Kaffeekonsum, der unter "
				+ "Anderem der Undurchschaubarkeit der repaint()-Methode "
				+ "geschuldet ist, zu einer erhöhten Koffeinkonzentration "
				+ "in der Kieler Förde geführt haben.\nAber hey, so haben " + // funny
				"die Fische auch was davon.";

		uppertext.setText(uppertextText);
		gl.add(uppertext);
	}

	/**
	 * Put things on thanks.
	 */
	private void putThingsOnThanks() {

		getThanks().setLayout(new FlowLayout(FlowLayout.CENTER, 10, 20));
		JTextArea uppertext = new JTextArea();
		uppertext.setRows(6);
		uppertext.setColumns(50);
		uppertext.setLineWrap(true);
		uppertext.setWrapStyleWord(true);
		String thanks = "Danksagung\n\nUnser besonderer Dank gilt unserer Tutorin" +
				" Insa Stucke, die uns mit Rat und Tat zur Seite stand und " +
				"sehr verständnisvoll auf unsere Terminwünsche eingegangen ist.";

		uppertext.setText(thanks);
		getThanks().add(uppertext);
	}
}