package view;

import java.awt.event.MouseListener;
import java.awt.event.MouseWheelListener;

import model.OceanInterface;

/**
 * The Interface OceanGUIInterface.
 */
public interface OceanGUIInterface {

	/**
	 * Gets the button panel.
	 * 
	 * @return the button panel
	 */
	public ButtonPanel getButtonPanel();

	/**
	 * Gets the my ocean.
	 * 
	 * @return the my ocean
	 */
	public OceanInterface getMyOcean();

	/**
	 * Gets the status panel.
	 * 
	 * @return the status panel
	 */
	public StatusPanel getStatusPanel();

	/**
	 * Gets the water panel.
	 * 
	 * @return the water panel
	 */
	public WaterPanel getWaterPanel();

	/**
	 * Sets the button panel.
	 * 
	 * @param buttonPanel
	 *            the new button panel
	 */
	public void setButtonPanel(ButtonPanel buttonPanel);

	/**
	 * Sets the my ocean.
	 * 
	 * @param myOcean
	 *            the new my ocean
	 */
	public void setMyOcean(OceanInterface myOcean);

	/**
	 * Sets the status panel.
	 * 
	 * @param statusPanel
	 *            the new status panel
	 */
	public void setStatusPanel(StatusPanel statusPanel);

	/**
	 * Sets the water panel.
	 * 
	 * @param waterPanel
	 *            the new water panel
	 */
	public void setWaterPanel(WaterPanel waterPanel);

	/**
	 * Show error message.
	 * 
	 * @param errorMsg
	 *            the error msg
	 */
	public void showErrorMessage(String errorMsg);


	/**
	 * Adds a the mouseListener to the GUI.
	 * 
	 * @param mouseController
	 * @param mouseController2
	 */
	public void addMouseListeners(MouseListener mouseController, MouseWheelListener mouseController2);
}
