package view;

import java.awt.Graphics;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import model.OceanInterface;
import model.OceanObject;

/**
 * The Class WaterPanel. Displays the ocean and its objects. Really awesome
 * stuff.
 */
public class WaterPanel extends JPanel implements Runnable {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 6386470435692411817L;

	/** The myOcean. */
	private OceanInterface myOcean;

	/**
	 * Instantiates a new water panel.
	 * 
	 * @param ocean
	 *            the ocean
	 */
	protected WaterPanel(OceanInterface ocean) {
		setMyOcean(ocean);
		setSize(getMyOcean().getWidth(), getMyOcean().getDepth());
		setVisible(true);
	}

	// ___________________________________________________________________________________________
	
	/**
	 * Gets the myOcean.
	 * 
	 * @return the myOcean
	 */
	protected OceanInterface getMyOcean() {
		return myOcean;
	}

	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);

		// paint background
		ImageIcon bild = new ImageIcon(
				getClass().getResource("/view/images/underwater_1500_600.png"));
				
				
				
		g.drawImage(bild.getImage(), 0, 0, getMyOcean().getWidth(),
				getMyOcean().getDepth() + 10, null);

		// paint the oceanObjects from oceanObjects (list)
		synchronized (getMyOcean().getOceanObjects()) {
			for (int k = getMyOcean().getOceanObjects().size() - 1; k >= 0; k--) {

				OceanObject obj = getMyOcean().getOceanObjects().get(k);
				g.drawImage(obj.getIcon().getImage(), obj.getPositionX(),
						obj.getPositionY(), null);
				repaint();
			}
		}
	}

	@Override
	public void run() {
		while (true) {

			if (getMyOcean().isOceanRunning()) {
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {
					System.out.println("WaterPanel: I can't get no sleep...");
				}
			}
		}
	}

	/**
	 * Sets the myOcean.
	 * 
	 * @param myOcean
	 *            the myOcean to set
	 */
	protected void setMyOcean(OceanInterface myOcean) {
		this.myOcean = myOcean;
	}
}
